/*------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        31.12.2007
 Description:    Analogeingnge Abfragen
------------------------------------------------------------------------------*/

#include "adc.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include "usart.h"

volatile unsigned int adc_counter = 0;

//------------------------------------------------------------------------------
//
void adc_init(void)
{ 
	ADMUX =  kanal;//((1<<REFS0)|(1<<REFS1))
	ANALOG_ON;//ADC ON	
}

//------------------------------------------------------------------------------
//
ISR (ADC_vect)
{
    ANALOG_OFF; //ADC OFF
	unsigned int tmp = ADC; 
	ANALOG_ON;//ADC ON
	
	if (tmp > 130) tmp-= 130;
	
	if((adc_counter++) < MAX_TX_DATA)
	{
		//tmp -= 50;
		if (tmp > ((tx_data1[adc_counter]<<8)+tx_data2[adc_counter])) 
		{
			tx_data1[adc_counter] = (tmp&0xFF00)>>8;
			tx_data2[adc_counter] = (tmp&0x00FF);	
		}
	}
}


