/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        17.10.2008
 Description:    MyScope

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
----------------------------------------------------------------------------*/
#include <avr/interrupt.h>
#include <avr/io.h>
#include "usart.h"
#include "adc.h"

volatile unsigned char transmit_counter = 0;

//----------------------------------------------------------------------------
ISR (INT0_vect)
{
    ANALOG_OFF; //ADC OFF
	adc_counter = 0;
	if(transmit_counter++ < 3)
	{
		for(unsigned long a = 0;a<19000;a++){asm("nop");};
		ANALOG_ON;//ADC ON
	}
}

//----------------------------------------------------------------------------
//Hier startet das Hauptprogramm
int main (void)
{   
    usart_init(57600);
	adc_init();
	EICRA |= (1<<ISC01)|(1<<ISC00);
	EIMSK |= (1<<INT0);
    sei();
    while(1)
    {
		if(transmit_counter > 5)
		{
			usart_transmit_frame();
			transmit_counter = 0;
		}
	}
}



