/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        17.10.2008
 Description:    RS232 Routinen

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/

#include "usart.h"
#include <avr/io.h>
#include <avr/interrupt.h>

volatile unsigned char tx_data1[MAX_TX_DATA];
volatile unsigned char tx_data2[MAX_TX_DATA];
volatile unsigned int tx_data_counter=0;	

//----------------------------------------------------------------------------
//Init serielle Schnittstelle
void usart_init(unsigned long baudrate) 
{ 
  	//Enable TXEN im Register UCR TX-Data Enable
	UCSR0B =(1 << TXEN0);
	//Teiler wird gesetzt 
	UBRR0L = (SYSCLK / (baudrate * 16L) - 1) & 0x00FF;
	UBRR0H = ((SYSCLK / (baudrate * 16L) - 1) & 0xFF00)>>8;
}

//----------------------------------------------------------------------------
//Init serielle Schnittstelle
void usart_transmit_frame(void) 
{ 
		UDR0 = 0xFF;
		while(!(UCSR0A & (1<<UDRE0)));
		UDR0 = 0xFF;
		while(!(UCSR0A & (1<<UDRE0)));
		UDR0 = 0xFF;
		while(!(UCSR0A & (1<<UDRE0)));
		UDR0 = 0xFF;
		while(!(UCSR0A & (1<<UDRE0)));
		
		for(tx_data_counter=0;tx_data_counter<MAX_TX_DATA;tx_data_counter++)
		{
			UDR0 = tx_data1[tx_data_counter];
			tx_data1[tx_data_counter] = 0x00;
			while(!(UCSR0A & (1<<UDRE0)));
			UDR0 = tx_data2[tx_data_counter];
			tx_data2[tx_data_counter] = 0x00;
			while(!(UCSR0A & (1<<UDRE0)));
		}
}






